#version 330

layout (std140) uniform Matrices
{
	mat4 m_pvm;
	mat4 m_viewModel;
	mat3 m_normal;
};

layout (std140) uniform Lights
{
	vec3 l_dir;		// camera space
};

in vec4 position;	// local space
in vec3 normal;		// local space
in vec3 tangent;	// local space
in vec3 bitangent;	// local space
in vec2 texCoord;

out Data
{
	vec3 normal;
	vec3 eye;
	vec3 light;
	vec2 texCoord;
} DataOut;

//----------------------------------------------------------------
// TODO:
// 1) Transform input normal, tangent and bitangent vectors with normal matrix.
// 2) Transform light into tangent space.
// 3) Transform eye into tangent space.
// 4) Don't forget to send computed data to fragment shader
// 5) Optional - compute bitangent vector from normal and tangent instead of using the passed one.
//----------------------------------------------------------------

void main()
{
	// Transform local coordinate space into camera space
	
	//TODO 1) Transform input normal, tangent and bitangent vectors with normal matrix


	//TODO 5) Compute bitangent vector from normal and tangent instead of using the passed one.
	//   Hint: use 'cross' function
	


#endif
	DataOut.normal = n; // Not needed, send for reference

	// Transform light and eye vectors into tangent space using this matrix:
	// tx ty tz
	// bx by bz
	// nx ny nz

	//TODO 2) Transform light vector from camera space to tangent space. 
	//   Hint: use 'dot'
	vec3 lightTangent; //light vector in tangent space

	
	// Transform eye into tangent space...
	//    Compute vector 'to-camera' in the camera space
	vec4 vertexView = -(m_viewModel * position);
	
	//    Convert homogeneous position into euclidean
	vec3 vertexViewEuklid = vertexView.xyz / vertexView.w;
	
	//TODO 3) Transform this vector into tangent space
	//   Hint: use 'dot'



	DataOut.texCoord = texCoord;

	//TODO 4) send computed vectors to fragment shader

	gl_Position = m_pvm * position;	
}